#ifndef __CONFIG_H_
#define __CONFIG_H_

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 64
#endif

/*
   Sorry for incorrect solution, but
   #include <rpc/types.h>
   generates lots of warnings
   about redefinitions of TRUE, FALSE and some other symbols.
   Libc guys can't even think about someone (glib, for example) could or will
   redefine this :)
 */

#define CONFIG_FILE ".gfb/gfbrc"
#define CLIPBOARD_PATH ".gfb/clipboard"
#define TD_FILE ".gfb/gfbtypes"
#define ICON_PATH ".gfb/icons/"
#define NUM_OF_COLUMNS 4

typedef enum
  {
    TREE_NODE_WORLD = 1,	/* Base node for tree  */
    TREE_NODE_LOCALHOST,	/* Local Host Node     */
    TREE_NODE_HOST,		/* Host node (SMB/FTP) */
    TREE_NODE_NETWORK,		/* Network Node        */
    TREE_NODE_HOTLIST,		/* Hotlist Node        */
    TREE_NODE_HOTLIST_ENTRY,	/* Hotlist Entry       */
    TREE_NODE_FILESYSTEM,	/* Filesystem Node     */
    TREE_NODE_DIR,		/* Directory Node      */
    FILE_LIST_DIR,		/* FileList Directory  */
    FILE_LIST_FILE,		/* FileList File       */
    FILE_LIST_FILESYSTEM,	/* FileList Filesystem */
    GFB_LAST_TYPEDEF = 63,	/* Upper range */
    GFB_SYMLINK = 64,		/* Flag indicating symlink */
    GFB_EXECUTABLE = 128,	/* Executable */
    GENERIC = 256		/* Future growth       */
  }
UniversalItemType;

typedef struct
  {
    gshort type;
    void *data;
  }
UniversalItem;

typedef struct
  {
    gchar *name, *action;
  }
GfbItemAction;

typedef struct
  {
    gchar *name;
    GList *actions;
    void *icons;		//Would be typecasted to GfbItemIcons *

  }
GfbTypeDef;

#define GFB_TYPE_DEF(item) ((GfbTypeDef *)item)
#define UNI_ITEM(item)  ((UniversalItem *)item)

gchar LOCAL_HOSTNAME[MAXHOSTNAMELEN];

extern GtkWidget *main_window;
extern GtkWidget *main_vbox;
extern GtkWidget *treelist_vbox;
extern GtkWidget *main_menubar;
extern GtkWidget *main_buttonbar;
extern GtkWidget *main_hpaned;
extern GtkWidget *main_treewin;
extern GtkWidget *main_tree;
extern GtkWidget *main_listwin;
extern GtkWidget *main_list;
extern GtkWidget *main_statusbar;
extern GtkWidget *main_history_box;
extern GtkWidget *toolbox_hbox;
extern GtkWidget *main_toolbox;
extern gchar *main_titles[NUM_OF_COLUMNS];
extern gint main_window_usize_x, main_window_usize_y, main_treewin_usize_x,
  main_treewin_usize_y, last_clipboard_op;
extern gint IN_ITEM_SELECT, IN_MAKE_DIR_LIST, IN_TREE_EXPAND;
extern gint main_window_destroy_handler;
extern GList *gfb_typedefs;
extern gboolean show_hidden, show_backup;
extern void append_slash (gchar *);
extern gint get_widget_width (GtkWidget *);
extern gint get_widget_height (GtkWidget *);
extern gchar *GFB_stddefs[GFB_LAST_TYPEDEF];
extern gint argc;
extern gchar **argv;
extern gboolean tree_view;

extern gchar *get_main_window_width (void);
extern gchar *get_main_window_height (void);
extern gchar *get_main_treewin_width (void);
extern gchar *get_main_treewin_height (void);

extern gchar *get_hidden_state (void);
extern void set_hidden_state (gchar *);

extern gchar *get_backup_state (void);
extern void set_backup_state (gchar *);

extern void set_main_window_width (gchar *);
extern void set_main_window_height (gchar *);
extern void set_main_treewin_width (gchar *);
extern void set_main_treewin_height (gchar *);

extern gboolean is_file (void *);
extern gboolean is_dir (void *);
extern gboolean is_hidden (gchar *);
extern gboolean is_backup (gchar *);

/* Reads a directory and returns list of subdirs in first GList ** and list of files in the se */
extern void read_dir (gchar *, GList **, GList **);
extern void *copy_fileinfo (void *);
extern void *copy_universalitem (void *);
extern gchar *absolutize_name (gchar *);
extern gchar *replace_pattern (gchar * string, gchar * pattern, gchar * replacement);
extern void gfb_execute(gchar *command);
#endif /* __CONFIG_H_ */



