/* dialogs.h -- GFB dialogs  declarations

 * Copyright (C) 1999 Yarick Rastrigin <yarick@relex.ru>
 *                    Steve Hill <sjhill@plutonium.net>
 *                    Dany de Bontridder <dany.db@tvd.be>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __DIALOGS_H_
#define __DIALOGS_H_

typedef enum
  {
    DLG_INFORMATION,
    DLG_QUESTION,
    DLG_WARNING,
    DLG_STOP,
    DLG_NEW_FOLDER,
    DLG_NEW_SYMLINK,
    DLG_COPYING,
    DLG_DELETING
  }
GFB_DIALOG_TYPE;

typedef enum
  {
    DLG_OK = 1,
    DLG_CANCEL,
    DLG_RETRY,
    DLG_OVERWRITE,
    DLG_OVERWRITE_ALL,
    DLG_IGNORE,
    DLG_IGNORE_ALL,
    DLG_SKIP,
    DLG_SKIP_ALL,
    DLG_APPEND,
    DLG_APPEND_ALL,
    DLG_DESTROY
  }
GFB_DLG_RETURN;

extern gint gfb_std_dialog (const gchar *, gint);
extern gchar *gfb_new_dir ();
extern gchar *gfb_new_symlink (gchar *);
extern gint gfb_copy_wrapper (GList *, gint);

#endif /* __DIALOGS_H__ */
